import { jsx as _jsx } from "react/jsx-runtime";
import { getControl } from 'handie-react';
import { EnumFilterStructuralWidget } from 'handie-react/dist/widgets/class';
export default class SelectEditEnumFilterWidget extends EnumFilterStructuralWidget {
    render() {
        const Select = getControl('Select');
        const Option = getControl('Option');
        const children = this.state.options.map((opt) => Option ? (_jsx(Option, { label: opt.label, value: opt.value }, `Option${opt.value}OfSelectEditEnumFilterWidget`)) : null);
        const showEmptyValueOption = this.getCommonBehavior('filter.showEmptyValueOption', false);
        if (showEmptyValueOption && Option) {
            children.unshift(_jsx(Option, { label: this.getCommonBehavior('filter.emptyValueOptionLabel'), value: "" }, "OptionAllOfSelectEditEnumFilterWidget"));
        }
        const props = {
            value: this.props.value,
            placeholder: this.getPlaceholder(),
            clearable: !showEmptyValueOption,
        };
        if (this.config.className) {
            props.className = this.config.className;
        }
        return Select ? (_jsx(Select, Object.assign({}, props, { onChange: (value) => this.onChange(value == null ? '' : value) }, { children: children }), void 0)) : null;
    }
}
