import { jsx as _jsx } from "react/jsx-runtime";
import { isNumber, getControl } from 'handie-react';
import { TextFilterStructuralWidget } from 'handie-react/dist/widgets/class';
export default class InputTextFilterWidget extends TextFilterStructuralWidget {
    render() {
        const props = {
            value: this.props.value,
            placeholder: this.getPlaceholder(),
        };
        if (this.config.className) {
            props.className = this.config.className;
        }
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.props.filter;
            if (isNumber(min)) {
                props.minLength = min;
            }
            if (isNumber(max)) {
                props.maxLength = max;
            }
        }
        const TextInput = getControl('TextInput');
        return TextInput ? (_jsx(TextInput, Object.assign({}, props, { onInput: (value) => this.onChange(value) }), void 0)) : null;
    }
}
