import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { getControl, } from 'handie-react';
import { FormViewStructuralWidget } from 'handie-react/dist/widgets/class';
export default class FormDialogViewWidget extends FormViewStructuralWidget {
    constructor() {
        super(...arguments);
        this.state = {
            loading: false,
            dataSource: {},
            value: {},
            validation: {},
            dialogVisible: false,
        };
    }
    closeDialog() {
        this.setState({ dialogVisible: false }, () => this.$$view.reset());
    }
    fetchData() {
        const ctx = this.$$view;
        const opener = ctx.getOpener();
        if (opener.getView().category === 'object' && ctx.getOne) {
            ctx.setBusy(true);
            ctx
                .getOne(opener.getValue(), (data) => {
                this.setState({ dataSource: data });
                ctx.setValue(data);
            })
                .finally(() => ctx.setBusy(false));
        }
    }
    componentDidMount() {
        const opener = this.$$view.getOpener();
        opener.on(`dialog-view-show.${opener.getId()}`, () => {
            this.setState({ dialogVisible: true }, () => this.fetchData());
        });
        this.on('submit', () => {
            this.$$view.insert(this.state.value, () => {
                if (opener.getView().category === 'list') {
                    opener.reload();
                }
                else {
                    opener.getParent().reload();
                }
                this.closeDialog();
            }, (message) => this.$$app.alert(message));
        });
    }
    componentWillUnmount() {
        const opener = this.$$view.getOpener();
        opener.off(`dialog-view-show.${opener.getId()}`);
    }
    render() {
        const Dialog = getControl('Dialog');
        const Button = getControl('Button');
        const Wait = getControl('Wait');
        const closeDialog = this.closeDialog.bind(this);
        return Dialog ? (_jsx(Dialog, Object.assign({ title: this.config.title, width: this.config.dialogWidth || 520, footer: Button ? (_jsxs(_Fragment, { children: [_jsx(Button, Object.assign({ onClick: closeDialog }, { children: "\u53D6\u6D88" }), void 0),
                    _jsx(Button, Object.assign({ color: "primary", onClick: () => this.$$view.submit() }, { children: "\u786E\u8BA4" }), void 0)] }, void 0)) : null, visible: this.state.dialogVisible, centered: true, disableMask: true, onClose: closeDialog }, { children: Wait ? (_jsx(Wait, Object.assign({ busy: this.state.loading }, { children: this.renderForm() }), void 0)) : null }), void 0)) : null;
    }
}
