import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isBoolean, capitalize, getControl, normalizeClassName, } from 'handie-react';
import { FormViewStructuralWidget } from 'handie-react/dist/widgets/class';
import defaultBehaviors from './behavior';
import style from './style.scss';
export default class FormViewWidget extends FormViewStructuralWidget {
    isActionBarOutside() {
        if (isBoolean(this.config.actionBarOutside)) {
            return this.config.actionBarOutside;
        }
        return isBoolean(this.getBehavior('actionBarOutside'))
            ? this.getBehavior('actionBarOutside')
            : this.getCommonBehavior('view.objectViewActionBarOutside', false);
    }
    resolveActionBarAlignment() {
        if (this.config.actionBarAlignment) {
            return this.config.actionBarAlignment;
        }
        return (this.getBehavior('actionBarAlignment') ||
            this.getCommonBehavior('view.objectViewActionBarAlignment', 'left'));
    }
    componentWillMount() {
        super.componentWillMount();
        this.setBehaviors('view.form', defaultBehaviors);
    }
    componentDidMount() {
        this.fetchData();
    }
    render() {
        const outside = this.isActionBarOutside();
        const Wait = getControl('Wait');
        const actionBar = this.renderActionBar(style['FormViewWidget-actionBar']);
        return Wait ? (_jsx(Wait, Object.assign({ className: normalizeClassName(style.FormViewWidget, style[`FormViewWidget--actionBar${capitalize(this.resolveActionBarAlignment())}`], { [style['FormViewWidget--actionBarOutside']]: outside }, this.config.className), busy: this.state.loading }, { children: outside ? (_jsxs(_Fragment, { children: [_jsx("div", Object.assign({ className: style['FormViewWidget-formContainer'] }, { children: this.renderForm({ className: style['FormViewWidget-form'] }) }), void 0), actionBar] }, void 0)) : (this.renderForm({
                className: style['FormViewWidget-form'],
                children: actionBar,
            })) }), void 0)) : null;
    }
}
